package com.hzya.frame.plugin.zjmaterielsynchronizationevent.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DSTransactional;
import com.hzya.frame.basedao.service.impl.BaseService;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.dao.IZjMaterielSynchronizationEventDao;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.entity.ZjMaterielSynchronizationEventDto;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.entity.ZjMaterielSynchronizationEventEntity;
import com.hzya.frame.plugin.zjmaterielsynchronizationevent.service.IZjMaterielSynchronizationEventService;
import com.hzya.frame.u8.base.inventory.dao.IInventoryDao;
import com.hzya.frame.u8.base.inventory.entity.InventoryEntity;
import com.hzya.frame.u8.base.inventory.service.IInventoryService;
import com.hzya.frame.u8.base.inventory.service.impl.InventoryService;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.apache.commons.beanutils.BeanUtils;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.regex.Pattern;


/***
 * 物料档案同步插件
 * @content:
 * @author 👻👻👻👻👻👻👻👻 gjh
 * @date 2025-03-03 10:56
 * @param
 * @return
 **/
public class ZjMaterielSynchronizationEventServiceImpl extends BaseService<ZjMaterielSynchronizationEventEntity, String> implements IZjMaterielSynchronizationEventService {

    private IZjMaterielSynchronizationEventDao zjMaterielSynchronizationEventDao;

    @Autowired
    public void setZjMaterielSynchronizationEventDao(IZjMaterielSynchronizationEventDao zjMaterielSynchronizationEventDao) {
        this.zjMaterielSynchronizationEventDao = zjMaterielSynchronizationEventDao;
        this.dao = zjMaterielSynchronizationEventDao;
    }

    @Autowired
    private IInventoryDao inventoryDao;
    @Autowired
    private IInventoryService iInventoryService;
    private String zjoa = "zjoa";
    private String zju8 = "zju8";
    private JSONObject setdata() {
        String str = "{\n" +
                "\t\"businessDataStr\": \"{\\\"formId\\\":\\\"-3905612378317895950\\\",\\\"systemRelationRecords\\\":[],\\\"formmain_0274\\\":{\\\"field0029\\\":\\\"1421502140902557985\\\",\\\"id\\\":\\\"-8326794273716286834\\\",\\\"state\\\":0,\\\"modify_member_id\\\":\\\"1421502140902557985\\\",\\\"start_date\\\":\\\"2025-03-17 14:31:41\\\",\\\"field0021\\\":\\\"2025-03-17 00:00:00\\\",\\\"ratifyflag\\\":0,\\\"sort\\\":0,\\\"ratify_member_id\\\":\\\"0\\\",\\\"start_member_id\\\":\\\"1421502140902557985\\\",\\\"approve_member_id\\\":\\\"0\\\",\\\"finishedflag\\\":0,\\\"modify_date\\\":\\\"2025-03-17 14:32:08\\\"},\\\"formson_0275\\\":[{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0033\\\":\\\"-8742017848273975919\\\",\\\"field0012\\\":\\\"1992327618862992707\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"单面PCB\\\",\\\"field0007\\\":\\\"测试01\\\",\\\"field0008\\\":\\\"-7484130195468762590\\\",\\\"id\\\":\\\"5166621963325295705\\\",\\\"field0042\\\":\\\"2373467247970043294\\\",\\\"field0043\\\":\\\"12001-单面板\\\",\\\"field0022\\\":\\\"-2945823222932814225\\\",\\\"field0044\\\":\\\"1\\\",\\\"field0047\\\":\\\"7938221701373775446\\\",\\\"field0004\\\":\\\"1\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"sort\\\":\\\"1\\\",\\\"field0040\\\":\\\"3672918071318364920\\\",\\\"groupsort\\\":1,\\\"field0017\\\":\\\"-3057298014166890271\\\",\\\"field0018\\\":\\\"6370474688113429014\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0012\\\":\\\"4344562897656367384\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0015\\\":\\\"修改型号、品牌、工艺属性、仓库名称、优选等级、物料属性、吉朗单位\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"双面PCB\\\",\\\"field0007\\\":\\\"测试02\\\",\\\"field0008\\\":\\\"3945246438468764198\\\",\\\"id\\\":\\\"4426722915502541386\\\",\\\"field0042\\\":\\\"5516680321955287005\\\",\\\"field0043\\\":\\\"12003-双面板\\\",\\\"field0022\\\":\\\"-2945823222932814225\\\",\\\"field0044\\\":\\\"1\\\",\\\"field0047\\\":\\\"7938221701373775446\\\",\\\"field0004\\\":\\\"2\\\",\\\"field0048\\\":\\\"-4037029836424066587\\\",\\\"field0005\\\":\\\"12003000100\\\",\\\"sort\\\":\\\"2\\\",\\\"field0040\\\":\\\"-922480551664794340\\\",\\\"groupsort\\\":1,\\\"field0017\\\":\\\"-8754053652716436337\\\",\\\"field0018\\\":\\\"2022562015180964941\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0033\\\":\\\"-8742017848273975919\\\",\\\"field0012\\\":\\\"1992327618862992707\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"多层板\\\",\\\"field0007\\\":\\\"测试03\\\",\\\"field0008\\\":\\\"-7484130195468762590\\\",\\\"id\\\":\\\"6700217056720145510\\\",\\\"field0042\\\":\\\"2373467247970043294\\\",\\\"field0043\\\":\\\"12005-多层板\\\",\\\"field0022\\\":\\\"-2945823222932814225\\\",\\\"field0044\\\":\\\"1\\\",\\\"field0047\\\":\\\"7938221701373775446\\\",\\\"field0004\\\":\\\"3\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"field0005\\\":\\\"12005000101\\\",\\\"sort\\\":\\\"3\\\",\\\"field0040\\\":\\\"3672918071318364920\\\",\\\"groupsort\\\":1,\\\"field0017\\\":\\\"-3057298014166890271\\\",\\\"field0018\\\":\\\"-8051278170201109560\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0033\\\":\\\"1524430637576637930\\\",\\\"field0034\\\":\\\"1729652777585822779\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0015\\\":\\\"修改型号、开发号、产品阶段、客户名、仓库名称\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"遥控板\\\",\\\"field0007\\\":\\\"测试04\\\",\\\"id\\\":\\\"-1866281705366601123\\\",\\\"field0042\\\":\\\"5516680321955287005\\\",\\\"field0043\\\":\\\"62103-工业变频驱动板\\\",\\\"field0044\\\":\\\"6\\\",\\\"field0047\\\":\\\"-7621841196549452634\\\",\\\"field0004\\\":\\\"4\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"field0005\\\":\\\"62100000211\\\",\\\"sort\\\":\\\"4\\\",\\\"field0040\\\":\\\"736429965137036948\\\",\\\"groupsort\\\":1,\\\"field0039\\\":\\\"XM-20180038\\\",\\\"field0018\\\":\\\"2022562015180964941\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0012\\\":\\\"1992327618862992707\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"轻触开关\\\",\\\"field0007\\\":\\\"测试05\\\",\\\"field0008\\\":\\\"1901179953174168965\\\",\\\"id\\\":\\\"7404795553887307250\\\",\\\"field0042\\\":\\\"5516680321955287005\\\",\\\"field0043\\\":\\\"12600-轻触开关\\\",\\\"field0022\\\":\\\"-2945823222932814225\\\",\\\"field0044\\\":\\\"1\\\",\\\"field0047\\\":\\\"-7621841196549452634\\\",\\\"field0004\\\":\\\"5\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"field0005\\\":\\\"12600000111\\\",\\\"sort\\\":\\\"5\\\",\\\"field0040\\\":\\\"3672918071318364920\\\",\\\"groupsort\\\":1,\\\"field0017\\\":\\\"-8754053652716436337\\\",\\\"field0018\\\":\\\"-534873453094682532\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0033\\\":\\\"-8742017848273975919\\\",\\\"field0034\\\":\\\"-7717856120092735875\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"传感器板\\\",\\\"field0007\\\":\\\"测试06_RI\\\",\\\"id\\\":\\\"-2951518770830882969\\\",\\\"field0042\\\":\\\"5516680321955287005\\\",\\\"field0043\\\":\\\"62915-传感器板\\\",\\\"field0044\\\":\\\"6\\\",\\\"field0047\\\":\\\"-7621841196549452634\\\",\\\"field0004\\\":\\\"6\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"sort\\\":\\\"6\\\",\\\"field0040\\\":\\\"-922480551664794340\\\",\\\"groupsort\\\":1,\\\"field0039\\\":\\\"XM-20200034\\\",\\\"field0018\\\":\\\"6370474688113429014\\\"},{\\\"field0032\\\":\\\"1421502140902557985\\\",\\\"field0033\\\":\\\"-8742017848273975919\\\",\\\"field0034\\\":\\\"-7717856120092735875\\\",\\\"formmain_id\\\":\\\"-1172979993326564802\\\",\\\"field0013\\\":\\\"111\\\",\\\"field0038\\\":\\\"6978528383202511421\\\",\\\"field0006\\\":\\\"传感器板\\\",\\\"field0007\\\":\\\"测试06\\\",\\\"id\\\":\\\"1340651432790608074\\\",\\\"field0042\\\":\\\"5516680321955287005\\\",\\\"field0043\\\":\\\"72915-传感器板\\\",\\\"field0044\\\":\\\"7\\\",\\\"field0047\\\":\\\"-7621841196549452634\\\",\\\"field0004\\\":\\\"7\\\",\\\"field0048\\\":\\\"-2560084027973350816\\\",\\\"sort\\\":\\\"7\\\",\\\"field0040\\\":\\\"2317333171132055743\\\",\\\"groupsort\\\":1,\\\"field0039\\\":\\\"XM-20200034\\\",\\\"field0018\\\":\\\"6370474688113429014\\\"}],\\\"relationRecords\\\":[{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"5166621963325295705\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"3163007693784369626\\\",\\\"id\\\":\\\"-3977344269764441491\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"4426722915502541386\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"5448927498492528800\\\",\\\"id\\\":\\\"3574938246926517342\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"6700217056720145510\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"-768818563401364880\\\",\\\"id\\\":\\\"-8423571161708672740\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"-1866281705366601123\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"-9215057759836618178\\\",\\\"id\\\":\\\"3664856462452212445\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0039\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"-1866281705366601123\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9115049651476019855\\\",\\\"toFormId\\\":\\\"1384236263744228883\\\",\\\"toMasterDataId\\\":\\\"816438522350684751\\\",\\\"id\\\":\\\"-4632848363322718906\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"7404795553887307250\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"7941582905197678345\\\",\\\"id\\\":\\\"-6536401734594246184\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"-2951518770830882969\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"-3706538923009948594\\\",\\\"id\\\":\\\"4066538004526941978\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0039\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"-2951518770830882969\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9115049651476019855\\\",\\\"toFormId\\\":\\\"1384236263744228883\\\",\\\"toMasterDataId\\\":\\\"-7683158415127722983\\\",\\\"id\\\":\\\"-3215076937339025930\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0043\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"1340651432790608074\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9186490075385345640\\\",\\\"toFormId\\\":\\\"-1932967999249168761\\\",\\\"toMasterDataId\\\":\\\"5216419279699984943\\\",\\\"id\\\":\\\"4265259303971143729\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"},{\\\"toSubDataId\\\":\\\"\\\",\\\"formType\\\":\\\"42\\\",\\\"fromFormId\\\":\\\"-3905612378317895950\\\",\\\"fieldName\\\":\\\"field0039\\\",\\\"fromMasterDataId\\\":\\\"-1172979993326564802\\\",\\\"dataInfo\\\":\\\"{\\\\\\\"pcView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"phoneView\\\\\\\":\\\\\\\"\\\\\\\",\\\\\\\"toVersion\\\\\\\":\\\\\\\"default_form\\\\\\\"}\\\",\\\"fromSubDataId\\\":\\\"1340651432790608074\\\",\\\"type\\\":\\\"1\\\",\\\"viewThrough\\\":\\\"0\\\",\\\"relationShipId\\\":\\\"-9115049651476019855\\\",\\\"toFormId\\\":\\\"1384236263744228883\\\",\\\"toMasterDataId\\\":\\\"-7683158415127722983\\\",\\\"id\\\":\\\"5954828029495822484\\\",\\\"memberId\\\":\\\"1421502140902557985\\\"}]}\",\n" +
                "\t\"formApp\": \"5784297048514708594\",\n" +
                "\t\"summaryId\": \"-2256569363321240680\",\n" +
                "\t\"currentActivityId\": \"start\",\n" +
                "\t\"eventType\": \"onProcessFinished\",\n" +
                "\t\"id\": \"6178499685666669290\",\n" +
                "\t\"affairId\": \"-1\"\n" +
                "\n" +
                "}";
        JSONObject jsonStr = new JSONObject();
        jsonStr.put("jsonStr",str);
        return jsonStr;
    }

    /**
     * @param requestJson
     * @return com.hzya.frame.web.entity.JsonResultEntity
     * @Author lvleigang
     * @Description 物料档案同步
     * @Date 11:39 上午 2025/3/17
     **/
    @Override
    @DSTransactional()
    public JsonResultEntity materielSynchronization(JSONObject requestJson) {
        requestJson = setdata();
        JSONObject reqJson = new JSONObject();
        JSONObject jsonStr = requestJson.getJSONObject("jsonStr");
        JSONObject businessDataStr = jsonStr.getJSONObject("businessDataStr");
        String formAppId = jsonStr.getString("formAppId");
        String eventType = jsonStr.getString("eventType");
        switch (eventType) {
            case "onBeforeStart"://发起前事件，验证物料重复
                String formmain_id = getFormmain_id(businessDataStr);
                if(formmain_id == null || "".equals(formmain_id)){
                    return BaseResult.getFailureMessageEntity("onBeforeStart流程监听事件，未获取到主表id");
                }
                ZjMaterielSynchronizationEventEntity entity = new ZjMaterielSynchronizationEventEntity();
                entity.setFormmain_id(formmain_id);
                entity.setDataSourceCode(zjoa);
                List<ZjMaterielSynchronizationEventEntity> list = zjMaterielSynchronizationEventDao.queryById(entity);
               if(list == null || list.size() == 0){
                   return BaseResult.getFailureMessageEntity("onBeforeStart流程监听事件，未获取到明细数据");
               }
                return checkData(list,false,null);
            case "onProcessFinished"://流程结束事件，同步物料到U8C
                String id = getFormmain_id(businessDataStr);
                if(id == null || "".equals(id)){
                    return BaseResult.getFailureMessageEntity("onProcessFinished流程监听事件，未获取到主表id");
                }
                ZjMaterielSynchronizationEventEntity entity1 = new ZjMaterielSynchronizationEventEntity();
                entity1.setFormmain_id(id);
                entity1.setDataSourceCode(zjoa);
                List<ZjMaterielSynchronizationEventEntity> list1 = zjMaterielSynchronizationEventDao.queryById(entity1);
                if(list1 == null || list1.size() == 0){
                    return BaseResult.getFailureMessageEntity("onProcessFinished流程监听事件，未获取到明细数据");
                }
                List<InventoryEntity> inventoryEntities1 = new ArrayList<>();
                JsonResultEntity jsonResultEntity = checkData(list1,true,inventoryEntities1);
                if(jsonResultEntity == null){
                    return BaseResult.getFailureMessageEntity("onProcessFinished流程监听事件，校验发生系统错误");
                }
                if(!jsonResultEntity.isFlag()){
                    return jsonResultEntity;
                }
                //组装数据，保存数据
                try {
                    saveMaterielToU8(list1,inventoryEntities1);
                    //回写U8生成的编码
                    updateOaCode(list1);
                }catch (Exception e){
                    throw new RuntimeException("保存u8数据错误："+e.getMessage());
                }
                return BaseResult.getSuccessMessageEntity("保存u8成功");
            case "onStart"://流程发起 oa数据重新排序
                return BaseResult.getSuccessMessageEntity("排序暂不处理");
            default:
                return BaseResult.getFailureMessageEntity("未匹配到流程监听事件！当前传入的eventType：" + eventType);
        }
    }


    /**
     * @Author lvleigang
     * @Description  回写U8生成的编码
     * @Date 10:04 上午 2025/3/19
     * @param list
     * @return void
     **/
    private void updateOaCode(List<ZjMaterielSynchronizationEventEntity> list) {
        if(list != null && list.size() > 0){
            for (int i = 0; i < list.size(); i++) {
                ZjMaterielSynchronizationEventEntity entity = list.get(i);
                if("新增".equals(entity.getField0018code()) || "增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                    entity.setDataSourceCode(zjoa);
                    zjMaterielSynchronizationEventDao.updatewlbm(entity);
                }
            }
        }
    }

    /**
     * @Author lvleigang
     * @Description  组装数据，保存数据
     * @Date 10:03 上午 2025/3/19
     * @param list
     * @return void
     **/
    private void saveMaterielToU8(List<ZjMaterielSynchronizationEventEntity> list,List<InventoryEntity> inventoryEntities) throws Exception {
        Map<String,Integer> lsh = new HashMap<>();//当前流水号
        List<InventoryEntity> savedata = new ArrayList<>();

        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            //获取最大流水号
            Integer maxnum = null;
            if(lsh.get(entity.getField0043code()) != null){
                maxnum = lsh.get(entity.getField0043code());
            }
            StringBuffer wlcode = new StringBuffer();
            //设置编码
            if("新增".equals(entity.getField0018code()) || "增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                if(entity.getField0043code().equals("12400")
                        || entity.getField0043code().equals("12500")
                        || entity.getField0043code().equals("12418")
                        || entity.getField0043code().equals("12001")
                        || entity.getField0043code().equals("12003")
                        || entity.getField0043code().equals("12005")){
                    //货品分类(12400-贴片电阻, 12500-贴片电容, 12418-贴片检测电阻, 12001-单面板, 12003-双面板, 12005-多层板)
                    //封装分类(贴片 0 , 其他 0 )
                    //当前分类最大流水号
                    //品牌(单据内填写品牌 01,未填写 00)
                    //是否委外
                    //是：勾选存货属性的委外，计划页面的委外属性
                    //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                    // 整体逻辑  12400物料分类 0贴片 002流水号  01品牌号
                    //例：12400  0 002 01
                    //货品分类以这几个开头的。封装分类是贴片，依然填0
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length()+1,entity.getField0043code().length()+4);
                        maxnum = Integer.valueOf(num);
                    }
                    String formattedNum = String.format("%03d", ++maxnum);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code()).append("0").append(formattedNum);
                    if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        wlcode.append("01");
                    }else {
                        wlcode.append("00");
                    }
                }else if(entity.getField0043code().startsWith("1") || entity.getField0043code().startsWith("4") || entity.getField0043code().startsWith("5")){
                    //货品分类(区分是否是原材料通过分类首位1,4,5)
                    //封装分类(贴片 9 , 其他 0 )
                    //当前分类最大流水号
                    //品牌(单据内填写品牌 01,未填写 00)
                    //是否委外
                    //是：勾选存货属性的委外，计划页面的委外属性
                    //否：取消勾选勾选存货属性的”委外”，计划页面的委外属性设置成“采购”
                    // 整体逻辑  12100物料分类 0非贴片 002流水号  01品牌号
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length()+1,entity.getField0043code().length()+4);
                        maxnum = Integer.valueOf(num);
                    }
                    String formattedNum = String.format("%03d", ++maxnum);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    if(entity.getField0017code() != null && "贴片".equals(entity.getField0017code())){
                        wlcode.append("9");
                    }else {
                        wlcode.append("0");
                    }
                    wlcode.append(formattedNum);
                    if(entity.getField0008code() != null && !"".equals(entity.getField0008code())){
                        wlcode.append("01");
                    }else {
                        wlcode.append("00");
                    }
                }else if(entity.getField0043code().startsWith("6") || entity.getField0043code().startsWith("7") || entity.getField0043code().startsWith("8") || entity.getField0043code().startsWith("8")){
                    //货品分类(区分是否是”产品”通过分类首位6,7,8,9)
                    //当前分类最大流水号（编码第6-9是顺序号）
                    //最后2位默认11
                    //整体逻辑  62100物料分类  0001流水  11默认
                    //例：62100 0001 11
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+4);
                        maxnum = Integer.valueOf(num);
                    }
                    String formattedNum = String.format("%04d", ++maxnum);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    wlcode.append(formattedNum);
                    wlcode.append("11");

                }else if(entity.getField0043code().startsWith("A")){
                    //货品分类(区分是”软件”通过分类首位A)
                    //当前分类最大流水号（编码第6-10是顺序号）
                    //最后1位默认1
                    //整体逻辑  A0110物料分类  00001流水  1默认
                    //例：A0110 00001 1
                    if(maxnum == null){
                        entity.setDataSourceCode(zju8);
                        String num = zjMaterielSynchronizationEventDao.queryMaxLsh(entity);
                        num = num.substring(entity.getField0043code().length(),entity.getField0043code().length()+5);
                        maxnum = Integer.valueOf(num);
                    }
                    String formattedNum = String.format("%05d", ++maxnum);
                    lsh.put(entity.getField0043code(),maxnum);
                    wlcode.append(entity.getField0043code());
                    wlcode.append(formattedNum);
                    wlcode.append("1");
                }
            }else if("修改".equals(entity.getField0018code())){
                wlcode.append(entity.getField0005());
            }
            //设置其他字段
            //物料编码
            InventoryEntity inventoryEntity = new InventoryEntity();
            //设置全部字段属性
            for (int i1 = 0; i1 < inventoryEntities.size(); i1++) {
                if(inventoryEntities.get(i1).getcInvCode().equals(entity.getField0043code())){
                    BeanUtils.copyProperties(inventoryEntity,inventoryEntities.get(i1));
                    break;
                }
            }
            entity.setField0005(wlcode.toString());
            //定制化字段
            inventoryEntity.setDataSourceCode(zju8);
            inventoryEntity.setAcc_name("UFDATA_999_2025.dbo.");
            inventoryEntity.setCacc_id("999");

            //inventoryEntity.setAcc_name("UFDATA_998_2014.dbo.");
            //inventoryEntity.setCacc_id("998");
            inventoryEntity.setcInvCode(wlcode.toString());//物料编码
            inventoryEntity.setcInvCCode(entity.getField0043code());//物料中类
            inventoryEntity.setcInvAddCode(entity.getField0045());//  货品代码
            inventoryEntity.setcInvName(entity.getField0006());//  货品名称
            inventoryEntity.setcInvStd(entity.getField0007());//  货品规格
            //inventoryEntity.setcInvCCode(entity.getField0008code());// todo 品牌
            //inventoryEntity.setcInvCCode(entity.getField0034code());// todo 客户名
            //inventoryEntity.setcInvCCode(entity.getField0017code());// todo 工艺属性
            inventoryEntity.setcDefWareHouse(entity.getField0040code());//  todo 仓库名称(值需要转换)
            //inventoryEntity.setcInvCCode(entity.getField0012code());// todo 优选等级
            //inventoryEntity.setbSrvItem(entity.getField0039());// todo 开发号(值需要转换)
            //inventoryEntity.setcInvCCode(entity.getField0042code());// todo 物料属性
            //inventoryEntity.setbProxyForeign(entity.getField0022code());//  是否委外
            //inventoryEntity.setcInvCCode(entity.getField0022code());// todo 计划属性字段不确定
            //inventoryEntity.setcInvCCode(entity.getField0033code());// todo 产品阶段
            //inventoryEntity.setcInvCCode(entity.getField0032code());// todo 负责人
            savedata.add(inventoryEntity);
            if("新增".equals(entity.getField0018code()) || "增加替代".equals(entity.getField0018code()) || "升级".equals(entity.getField0018code())){
                iInventoryService.saveInventory(inventoryEntity);
            }else if("修改".equals(entity.getField0018code())){
                iInventoryService.updateInventory(inventoryEntity);
            }
        }
    }




    /**
     * @Author lvleigang
     * @Description  解析参数id
     * @Date 11:38 上午 2025/3/18
     * @param businessDataStr
     * @return java.lang.String
     **/
    private String getFormmain_id(JSONObject businessDataStr) {
        String id = null;
        if(businessDataStr == null ){
            return id;
        }
        JSONObject formmain_0274 = businessDataStr.getJSONObject("formmain_0274");
        if(formmain_0274 == null){
            return id;
        }
        id = formmain_0274.getString("id");
        return id;
    }

    /**
     * @Author lvleigang
     * @Description  验证物料重复
     * @Date 1:58 下午 2025/3/17
     * @param list 数据
     * @param flag 该项是否校验
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    private JsonResultEntity checkData(List<ZjMaterielSynchronizationEventEntity> list, boolean flag,List<InventoryEntity> inventoryEntities) {
        // 定义正则表达式，匹配全角符号
        String regex = "[\uFF00-\uFFEF]";
        // 编译正则表达式
        Pattern pattern = Pattern.compile(regex);
        Integer num = 0;
        Integer num1 = 0;
        /*
        1、必填校验：发起
				物料中类、货品编码（修改必填）
				保存
				物料中类、货品编码（修改必填）、货品代码、品牌、客户名、优选等级、开发号、物料属性、是否委外
        2、物料编码和货品代码不为空时，判断两个是否一样
        3、判断存货分类里面如果有6或7，有一个必须有另一个
        4、规格型号正则校验（不允许全角符号）
        5、发起、保存判断物料分类是否在U8中存在
        */
        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            if(entity.getField0004() == null || "".equals(entity.getField0004())){
                return BaseResult.getFailureMessageEntity("序号为空");
            }
            if(entity.getField0043code() == null || "".equals(entity.getField0043code())){
                return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料中类为空");
            }else {
                //判断存货分类里面如果有6或7，有一个必须有另一个
                if(entity.getField0043code().startsWith("6")){
                    num++;
                }
                if(entity.getField0043code().startsWith("7")){
                    num1++;
                }
            }
            //if(entity.getField0018code() == null || "".equals(entity.getField0018code())){
            //    return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的申请原因为空");
            //}
            if("修改".equals(entity.getField0018code())){
                if(entity.getField0005() == null || "".equals(entity.getField0005())){
                    return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的货品编码为空");
                }
            }
            //if(flag){
            //    if(entity.getField0045() == null || "".equals(entity.getField0045())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的货品代码为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0008code() == null || "".equals(entity.getField0008code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的品牌为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0034code() == null || "".equals(entity.getField0034code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的客户名为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0012code() == null || "".equals(entity.getField0012code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的优选等级为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0039() == null || "".equals(entity.getField0039())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的开发号为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0042code() == null || "".equals(entity.getField0042code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料属性为空");
            //    }
            //}
            //if(flag){
            //    if(entity.getField0022code() == null || "".equals(entity.getField0022code())){
            //        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的是否委外为空");
            //    }
            //}
            //物料编码和货品代码不为空时，判断两个是否一样
            if(entity.getField0005() != null && !"".equals(entity.getField0005())
                && entity.getField0045() != null && !"".equals(entity.getField0045())){
                if(!entity.getField0005().equals(entity.getField0045())){
                    return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料编码和货品代码不一致");
                }
            }
            //规格型号正则校验（不允许全角符号）
            if(entity.getField0007() != null && !"".equals(entity.getField0007())){
                if(pattern.matcher(entity.getField0007()).find()){
                    return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的规格型号包含全角符号");
                }
            }
        }
        //判断存货分类里面如果有6或7，有一个必须有另一个
        if(num > 0){
            if(num1 == 0){
                return BaseResult.getFailureMessageEntity("存货分类存在6，不存在7");
            }
        }
        if(num1 > 0){
            if(num == 0){
                return BaseResult.getFailureMessageEntity("存货分类存在7，不存在6");
            }
        }
        //查询u8物料
        ZjMaterielSynchronizationEventDto querywl = new ZjMaterielSynchronizationEventDto();
        querywl.setDataSourceCode(zju8);
        querywl.setZjMaterielSynchronizationEventEntities(list);
        List<InventoryEntity> inventoryEntities1 = zjMaterielSynchronizationEventDao.queryInventoryEntity(querywl);
        inventoryEntities.addAll(inventoryEntities1);
        if(inventoryEntities == null || inventoryEntities.size() == 0){
            return BaseResult.getFailureMessageEntity("物料分类在U8中不存在");
        }
        //发起、保存判断物料分类是否在U8中存在
        for (int i = 0; i < list.size(); i++) {
            ZjMaterielSynchronizationEventEntity entity = list.get(i);
            boolean flags = false;
            for (int i1 = 0; i1 < inventoryEntities.size(); i1++) {
                if(entity.getField0043code().equals(inventoryEntities.get(i1).getcInvCode())){
                    flags = true;
                    break;
                }
            }
            if(!flags){
                return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行的物料分类在U8中不存在");
            }
        }

        //	新增
        //		A6789分类时：判断存货分类和规格型号在物料分类中是否存在，存在不允许新增
        //		145分类时：判断规格型号是否存在，存在不允许新增
        //		其他类型，直接返回提示类型错误
        //	修改判断
        //		物料编码判断U8是否存在，不存在的提示
        if(flag){
            Integer xzCount = 0;
            Set<String> js = new HashSet<>();
            for (int i = 0; i < list.size(); i++) {
                ZjMaterielSynchronizationEventEntity entity = list.get(i);
                if("修改".equals(entity.getField0018code())){
                    //查询u8物料
                    InventoryEntity queryCz = new InventoryEntity();
                    queryCz.setDataSourceCode(zju8);
                    queryCz.setcInvCode(entity.getField0005());
                    List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                    if(queryCzList == null || queryCzList.size() == 0 ){
                        //return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行修改的物料编码在U8中不存在");
                        return BaseResult.getFailureMessageEntity(entity.getField0005()+"已存在U8中不存在,请检查货品编号");
                    }

                }else {//新增/增加替代/升级
                    xzCount++;
                    if(entity.getField0043code().startsWith("a")
                            || entity.getField0043code().startsWith("6")
                            || entity.getField0043code().startsWith("7")
                            || entity.getField0043code().startsWith("8")
                            || entity.getField0043code().startsWith("9")){
                        //查询u8物料
                        InventoryEntity queryCz = new InventoryEntity();
                        queryCz.setDataSourceCode(zju8);
                        queryCz.setcInvCCode(entity.getField0043code());//存货分类/存货大类编码
                        queryCz.setcInvStd(entity.getField0007());//规格型号
                        List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                        if(queryCzList != null && queryCzList.size() > 0 ){
                            return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的存货分类和规格型号已存在");
                        }
                        js.add(entity.getField0043code()+entity.getField0007());
                    }else if(entity.getField0043code().startsWith("1")
                            || entity.getField0043code().startsWith("4")
                            || entity.getField0043code().startsWith("5")){
                        //查询u8物料
                        InventoryEntity queryCz = new InventoryEntity();
                        queryCz.setDataSourceCode(zju8);
                        queryCz.setcInvStd(entity.getField0007());//规格型号
                        List<InventoryEntity> queryCzList = inventoryDao.query(queryCz);
                        if(queryCzList != null && queryCzList.size() > 0 ){
                            return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的规格型号已存在");
                        }
                        js.add(entity.getField0007());
                    }else {
                        return BaseResult.getFailureMessageEntity("序号为"+entity.getField0004()+"明细行"+entity.getField0018code()+"的物料中类不正确");
                    }
                }
            }
            if(js.size() != xzCount ){
                return BaseResult.getFailureMessageEntity("新增/增加替代/升级的明细行存货分类和规格型号或者规格型号存在重复");
            }
        }
        return BaseResult.getSuccessMessageEntity("校验成功");
    }


}
